
; Pulsa CityCenter
; GPT

; PAOV 1010 PA overflow IVBA:1010
; PAI  1011 PA input    IVBA:1011

; TMSK2: PAOVI PAII
; TFLG2: PAOVF PAIF

; IVBA 4
; IPL 6
; IPA 9

; PACTL/PACNT 0xF90C
; TMSK1/TMSK2 0xF920 PAOVI bit5 PAII bit4 kernel init 0x1002

	section  .bankf
	align 1

PACNT_ext ds.w 2   ; extend PA to 32 (and over)

	section .inthand
	align 1

PAOVInt

	pshm d,k
	ldab # 0FFh
	tbek

	bclr 0F923h, # 20h  ; clear PAOVF from TFLG2

	incw PACNT_ext + 2
	bne  L1
	incw PACNT_ext + 0
L1
	pulm d,k
	rti

	section .text
	align 1

	global _init_pulsacc

_init_pulsacc

	pshm k

	clrb
	tbek

	ldd  # PAOVInt
	std  0094h   ; change vector IVBA:1010

	ldab # 0FFh
	tbek

	ldd  # 4000h       ; PACNT enable, falling edges, OC5 enable/IC4 disable
	std  0F90Ch        ; PACTL
	bset 0F921h, # 20h ; TMSK2: enable PAOVI

	pulm k
	rts

	global _read_pulsacc

_read_pulsacc             ; dword _read_pulsacc(stamp *when)

	tste
	beq  L20              ; no time requested

	xgex
	lded time
	ste  0,x
	std  2,x
L20
	pshm k
	ldab # 0FFh
	tbek                  ; EXT F
L2
	lde  PACNT_ext + 1    ; bits 31 ... 16 in ram
	ldaa PACNT_ext + 3    ; bits 15 ... 8 in ram
	ldab 0F90Dh           ; bits 7 ... 0 in PACNT
	cmpa PACNT_ext + 3    ; interrupt during read ?
	bne  L2
	cpe  PACNT_ext + 1
	bne  L2               ; if so, just do it all again

	pulm k
	rts

