
	global	_word_bitmask

	section	.data
	align	1
_word_bitmask
	dc.w	1
	dc.w	2
	dc.w	4
	dc.w	8
	dc.w	16
	dc.w	32
	dc.w	64
	dc.w	128
	dc.w	256
	dc.w	512
	dc.w	1024
	dc.w	2048
	dc.w	4096
	dc.w	8192
	dc.w	16384
	dc.w	-32768

	global	_byte_bitmask
_byte_bitmask
	dc.b	1
	dc.b	2
	dc.b	4
	dc.b	8
	dc.b	16
	dc.b	32
	dc.b	64
	dc.b	128

	global	_hex_characters
_hex_characters
	dc.b	030h,031h,032h,033h,034h,035h,036h,037h
	dc.b	038h,039h,041h,042h,043h,044h,045h,046h
	dc.b	047h,048h,049h,04Ah,04Bh,04Ch,04Dh,04Eh
	dc.b	04Fh,050h,051h,052h,053h,054h,055h,056h
	dc.b	000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1

	global	_strstr
_strstr
	pshm	z
	ais	#-10
	tsz

	ste	2,z
	std	4,z
	lde	4,z
	jsr	_strlen
	std	6,z
	beq	L8
	
	lde	2,z
	jsr	_strend
	tdy	
	tye	
	sube	6,z
	ste	8,z
	bra	L10
	

L6	lde	6,z
	ste	0,z
	lde	4,z
	ldd	2,z
	jsr	_bcmp
	tstd	
	beq	L8
	
	incw	2,z

L10	lde	2,z
	cpe	8,z
	bls	L6
	
	clrw	2,z

L8	ldd	2,z

	ais	#+10
	pulm	z
	rts

	align	1

	global	_strcatx
_strcatx
	pshm	z
	ais	#-2
	tsz

	std	0,z
	jsr	_strend
	tde	
	ldd	0,z
	jsr	_strcpyx

	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_short
_print_short
	pshm	z
	ais	#-6
	tsz

	ted	
	tze	
	jsr	_sprint_u
	tze	
	jsr	_print_string

	ais	#+6
	pulm	z
	rts

	align	1

	global	_print_02u
_print_02u
	pshm	z
	ais	#-6
	tsz

	ted	
	stz	4,z
	lde	4,z
	jsr	_sprint_02u
	tdy	
	clr	0,y
	lde	4,z
	jsr	_print_string

	ais	#+6
	pulm	z
	rts

	align	1

	global	_print_signed_short
_print_signed_short
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	ble	L15
	
	lde	#43
	jsr	_putchar
	lde	0,z
	jsr	_print_short
	bra	L14
	

L15	tstw	0,z
	bge	L16
	
	lde	#45
	jsr	_putchar
	lde	0,z
	nege	
	jsr	_print_short
	bra	L14
	

L16	lde	#32
	jsr	_putchar
	lde	#48
	jsr	_putchar

L14
	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_short_N
_print_short_N
	pshm	z
	ais	#-10
	tsz

	tey	
	std	6,z
	tze	
	tyd	
	jsr	_sprint_u
	std	8,z
	bra	L22
	

L20	lde	#32
	jsr	_putchar

L22	lde	8,z
	tzd	
	sde	
	incw	8,z
	cpe	6,z
	blt	L20
	
	tze	
	jsr	_print_string

	ais	#+10
	pulm	z
	rts

	align	1

	global	_print_signed_long
_print_signed_long
	pshm	z
	ais	#-16
	tsz

	ste	12,z
	std	14,z
	tste	
	bge	L24
	
	tze	
	aie	#12
	jsr	_lnegate
	lde	#45
	jsr	_putchar

L24	tzd	
	aid	#12
	tze	
	jsr	_sprint_010Lu
	tzy	
	ldab	0,z
	cmpb	#48
	bne	L27
	

L30	tst	1,y
	beq	L27
	
	xgdy	
	addd	#1
	xgdy	
	ldab	0,y
	cmpb	#48
	beq	L30
	

L27	tye	
	jsr	_print_string

	ais	#+16
	pulm	z
	rts

	align	1

	global	_print_dword
_print_dword
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	ldy	0,z
	lde	0,y
	jsr	_print_word
	ldy	0,z
	lde	2,y
	jsr	_print_word

	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_buf
_print_buf
	pshm	z
	ais	#-4
	tsz

	std	0,z
	ste	2,z
	bra	L37
	

L35	ldy	2,z
	ldab	0,y
	clra	
	incw	2,z
	tde	
	jsr	_print_byte

L37	decw	0,z
	ldy	0,z
	cpy	#-1
	bne	L35
	

	ais	#+4
	pulm	z
	rts

	align	1

	global	_sscan_num
_sscan_num
	pshm	z
	ais	#-6
	tsz

	ste	0,z
	std	4,z
	clry	

L39	ldx	0,z
	ldab	0,x
	incw	0,z
	addb	#-48
	stab	2,z
	cmpb	#9
	bhi	L42
	
	tye	
	asle	
	asle	
	tyd	
	ade	
	asle	
	tey	
	ldab	2,z
	clra	
	tde	
	xgey	
	ade	
	xgey	
	decw	4,z
	bne	L39
	
	tyd	
	bra	L44
	

L42	ldd	#-1

L44
	ais	#+6
	pulm	z
	rts

	align	1

	global	_sscan_hex
_sscan_hex
	pshm	z
	ais	#-4
	tsz

	tex	
	tdy	
	clre	

L46	ldab	0,x
	stab	0,z
	xgdx	
	addd	#1
	xgdx	
	addb	#-48
	stab	2,z
	cmpb	#9
	bls	L57
	
	ldab	0,z
	addb	#-65
	cmpb	#5
	bhi	L51
	
	ldab	0,z
	addb	#-55
	bra	L57
	

L51	ldab	0,z
	addb	#-97
	cmpb	#5
	bls	L53
	
	ldd	#-1
	bra	L56
	

L53	ldab	0,z
	addb	#-87

L57	stab	0,z
	asle	
	asle	
	asle	
	asle	
	ldab	0,z
	clra	
	pshm	d
	ore	-2,z
	ais	#+2
	xgdy	
	addd	#-1
	xgdy	
	lbne	L46
	
	ted	

L56
	ais	#+4
	pulm	z
	rts

	align	1

	global	_wildmat
_wildmat
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	jmp	L81
	

L62	ldy	0,z
	ldab	0,y
	cmpb	#42
	bne	L63
	

L64	incw	0,z
	ldy	0,z
	ldab	0,y
	cmpb	#42
	beq	L64
	
	ldy	0,z
	tst	0,y
	lbeq	L82
	
	bra	L69
	

L71	ldd	2,z
	incw	2,z
	lde	0,z
	jsr	_wildmat
	tstb	
	bne	L82
	

L69	ldy	2,z
	tst	0,y
	bne	L71
	

L84	clrd	
	bra	L80
	

L63	ldy	0,z
	ldab	0,y
	cmpb	#63
	bne	L74
	
	ldy	2,z
	tst	0,y
	bne	L61
	
	bra	L84
	

L74	ldy	2,z
	ldab	0,y
	ldy	0,z
	cmpb	0,y
	bne	L84
	

L61	incw	2,z
	incw	0,z

L81	ldy	0,z
	tst	0,y
	lbne	L62
	
	clrd	
	ldy	2,z
	tst	0,y
	bne	L80
	

L82	ldd	#1

L80
	ais	#+4
	pulm	z
	rts



	end
