
	section	.data
	align	1
_meas
	dc.w	0
	dc.b	0
	dc.b	3
	dc.w	16383
	dc.w	0
	dc.b	0
	dc.b	5
	dc.w	4095

	section	.text
	align	1
_update
	pshm	z
	ais	#-56
	tsz

	ldd	_meas
	std	16,z
	clrw	14,z
	ldd	#50
	std	0,z
	clrw	2,z
	clre	
	ldd	16,z
	jsr	_EDIV
	tde	
	aie	#-80
	jsr	_thermometer
	ldd	_meas+6
	std	12,z
	lde	#2684
	jsr	_EMUL
	ste	18,z
	std	20,z
	ldd	2+18,z
	addd	#335544       & $FFFF
	std	2+22,z
	ldd	0+18,z
	adcb	#335544 >> 16 & $FF
	adca	#335544 >> 24 & $FF
	std	0+22,z
	lde	_temperature_celsius_lo
	aie	#-25
	jsr	_abs
	tde	
	ste	0,z
	lde	22,z
	ldd	24,z
	jsr	_EMULx
	ste	4,z
	tzy	
	xgdy	
	addd	#4
	xgdy	
	std	2,y
	lde	_temperature_celsius_lo
	cpe	#24
	bgt	L2
	
	tye	
	jsr	_lnegate

L2	ldd	12,z
	std	0,z
	lde	#20
	ldd	#48234
	jsr	_EMULx
	ste	30,z
	std	32,z
	lde	12,z
	ldd	12,z
	jsr	_EMUL
	ste	34,z
	std	36,z
	ldd	#94
	std	0,z
	lde	34,z
	ldd	36,z
	jsr	_EMULx
	ste	38,z
	std	40,z
	ldd	2+30,z
	subd	2+38,z
	std	2+46,z
	ldd	0+30,z
	sbcb	1+38,z
	sbca	0+38,z
	std	0+46,z
	ldd	46,z
	std	8,z
	tzy	
	xgdy	
	addd	#8
	xgdy	
	ldd	48,z
	std	2,y
	ldd	2+4,z
	addd	#-134217728       & $FFFF
	std	2+42,z
	ldd	0+4,z
	adcb	#-134217728 >> 16 & $FF
	adca	#-134217728 >> 24 & $FF
	std	0+42,z
	ldd	2+8,z
	addd	2+42,z
	std	2+50,z
	ldd	0+8,z
	adcb	1+42,z
	adca	0+42,z
	std	0+50,z
	ldd	50,z
	std	8,z
	ldd	52,z
	std	2,y
	ldab	8,z
	lsrb	
	stab	54,z
	clra	
	tde	
	ste	_relative_humidity
	ldab	#1
	stab	_have_hygrometer

	ais	#+56
	pulm	z
	rts


	section	.data

LC0	dc.b	063h,072h,063h,020h,072h,065h,063h,065h
	dc.b	069h,076h,065h,064h,020h,030h,078h,000h

	align	1	; ASM_OUTPUT_ASCII

LC1	dc.b	02Ch,020h,063h,061h,06Ch,063h,075h,06Ch
	dc.b	061h,074h,065h,064h,020h,030h,078h,000h

	align	1	; ASM_OUTPUT_ASCII

	section	.text
	align	1
_unload
	pshm	z
	ais	#-8
	tsz

	ste	4,z
	jsr	_SHT1x_result
	tstd	
	beq	L10
	
	ldy	4,z
	lde	4,y
	come	
	ande	0,y
	bne	L10
	
	ldy	4,z
	tstw	0,y
	bne	L6
	

L10	clrd	
	bra	L9
	

L6	ldy	#140
	sty	0,z
	ldy	#2
	sty	2,z
	lde	4,z
	clrd	
	jsr	_crc_generic
	stab	6,z
	tstw	_debug
	beq	L7
	
	ldy	4,z
	ldab	2,y
	cmpb	6,z
	beq	L7
	
	lde	#LC0
	jsr	_print_string
	ldy	4,z
	ldab	2,y
	clra	
	tde	
	jsr	_print_word
	lde	#LC1
	jsr	_print_string
	ldab	6,z
	clra	
	tde	
	jsr	_print_word
	jsr	_eol

L7	clre	
	ldy	4,z
	ldab	2,y
	cmpb	6,z
	bne	L8
	
	lde	#1

L8	ted	

L9
	ais	#+8
	pulm	z
	rts


	section	.bss
Ltoggle.6
	ds.b	2

	section	.text
	align	1

	global	_sht1x_round
_sht1x_round
	pshm	z
	tsz

	cpe	#1
	beq	L18
	
	cpe	#2
	beq	L15
	
	jsr	_SHT1x_sync
	lde	#30
	jsr	_SHT1x_command
	tstd	
	lbeq	L11
	
	clrw	Ltoggle.6
	jmp	L11
	

L15	lde	Ltoggle.6
	asle	
	adde	Ltoggle.6
	asle	
	aie	#_meas
	jsr	_unload
	tstb	
	beq	L11
	
	lde	Ltoggle.6
	eore	#1
	ste	Ltoggle.6
	bne	L18
	
	jsr	_update

L18	lde	Ltoggle.6
	asle	
	adde	Ltoggle.6
	asle	
	tey	
	xgdy	
	addd	#_meas
	xgdy	
	ldab	3,y
	clra	
	tde	
	jsr	_SHT1x_command

L11	pulm	z
	rts



	end
