
static void
make_raw(struct termios *t)
{
	t->c_cflag &= ~CSIZE;
	t->c_cflag |= CS8;
	t->c_cflag &= ~PARENB;
	t->c_cflag &= ~CSTOPB;
	t->c_cflag &= ~HUPCL;
	t->c_cflag |= CLOCAL;
	t->c_cflag |= CREAD;

	t->c_iflag &= ~(IGNBRK | BRKINT | IGNPAR | IGNCR | ISTRIP);
	t->c_iflag &= ~(IXON | IXOFF | IMAXBEL | ICRNL | INLCR);
	t->c_iflag |= (INPCK | PARMRK | IXANY);

	t->c_lflag &= ~(ISIG | ICANON | IEXTEN | ECHO | ECHONL);

	t->c_oflag &= ~(OPOST); /* someone had a good idea */
}

