
#include "standard.h"

STATIC word dev = 0x90;

STATIC byte aout, fill_1, ain[4];

void
pcf8591_round()
{
	byte buf[5];

	buf[0] = 0x47; /* single-ended inputs, autoincrement from ch3 */
	buf[1] = aout;

	if (i2c_wr(dev, buf, 2)) {

		/* first adc byte will be stale ain3 */

		if (i2c_rd(dev, buf, 5))
			bcopy(buf + 1, ain, 4);
	}
}

